$NetBSD$

--- src/mod/xml_int/mod_xml_rpc/mod_xml_rpc.c.orig	2016-09-08 23:47:59.100492168 +0000
+++ src/mod/xml_int/mod_xml_rpc/mod_xml_rpc.c
@@ -246,7 +246,7 @@ static switch_status_t http_stream_write
 }
 
 static abyss_bool user_attributes(const char *user, const char *domain_name,
-								  const char **ppasswd, const char **pvm_passwd, const char **palias, const char **pallowed_commands)
+								  char **ppasswd, char **pvm_passwd, char **palias, char **pallowed_commands)
 {
 	const char *passwd;
 	const char *vm_passwd;
@@ -318,7 +318,7 @@ static abyss_bool user_attributes(const
 	return TRUE;
 }
 
-static abyss_bool is_authorized(const TSession * r, const char *command)
+static abyss_bool is_authorized(TSession * r, const char *command)
 {
 	char *user = NULL, *domain_name = NULL;
 	char *allowed_commands = NULL;
@@ -400,8 +400,8 @@ static abyss_bool http_directory_auth(TS
 	char z[256] = "", t[80] = "";
 	char user[512] = "" ;
 	char *pass = NULL;
-	const char *mypass1 = NULL, *mypass2 = NULL;
-	const char *box = NULL;
+	char *mypass1 = NULL, *mypass2 = NULL;
+	char *box = NULL;
 	int at = 0;
 	char *dp = NULL;
 	abyss_bool rval = FALSE;
@@ -650,7 +650,7 @@ abyss_bool websocket_hook(TSession *r)
 						continue;
 					}
 					p += 6;
-					if (p = strchr(p, ' ')) p++;
+					if ((p = strchr(p, ' '))) p++;
 					if (!strncasecmp(p, "json ", 5)) {
 						p += 5;
 					} else if (!strncasecmp(p, "xml ", 4)) {
@@ -663,7 +663,7 @@ abyss_bool websocket_hook(TSession *r)
 						break;
 					} else {
 					}
-					if (subclass = strchr(p, ' ')) {
+					if ((subclass = strchr(p, ' '))) {
 						*subclass++ = '\0';
 						if (!*subclass) {
 							switch_log_printf(SWITCH_CHANNEL_LOG, SWITCH_LOG_ERROR, "missing subclass\n");
@@ -798,6 +798,7 @@ static abyss_bool HTTPWrite(TSession * s
 	return ConnWrite(s->connP, buffer, len);
 }
 
+#if 0
 static abyss_bool HTTPWriteEnd(TSession * s)
 {
 	if (!s->chunkedwritemode)
@@ -812,6 +813,7 @@ static abyss_bool HTTPWriteEnd(TSession
 	s->requestInfo.keepalive = FALSE;
 	return TRUE;
 }
+#endif
 
 abyss_bool handler_hook(TSession * r)
 {
@@ -919,7 +921,7 @@ abyss_bool handler_hook(TSession * r)
 				if (len > 0) {
 					int succeeded = TRUE;
 					char *qp = qbuf;
-					char *readError;
+					const char *readError;
 
 					do {
 						int blen = r->connP->buffersize - r->connP->bufferpos;
@@ -944,7 +946,6 @@ abyss_bool handler_hook(TSession * r)
 						ConnRead(r->connP, 2000, NULL, NULL, &readError);
 		                if (readError) {
 							succeeded = FALSE;
-							free(readError);
 						}
 
 					} while (succeeded);
@@ -970,7 +971,7 @@ abyss_bool handler_hook(TSession * r)
 			do {
 				char *p;
 
-				if (next = strchr(next, '&')) {
+				if ((next = strchr(next, '&'))) {
 					if (!query) {
 						/* pass kv pairs from uri to query       */
 			            /* "?" is absent in url so parse uri     */
@@ -1113,7 +1114,7 @@ static xmlrpc_value *freeswitch_api(xmlr
 		return NULL;
 	}
 
-	if (!is_authorized((const TSession *) callInfo, command)) {
+	if (!is_authorized(callInfo, command)) {
 		val = xmlrpc_build_value(envP, "s", "UNAUTHORIZED!");
 		goto end;
 	}
